Overview | Package | Class | Use | Tree | Deprecated | Index | Help
|  | BEA Systems, Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## Type-Safe Access to BEA WebLogic Server 9.1 MBeans (Deprecated)
(Methods marked with @since 9.0.0.0 or later are not available through the deprecated `MBeanHome` interface.)

## weblogic.management.runtime
Interface JMSServerRuntimeMBean

All Superinterfaces:
  weblogic.management.runtime.CursorRuntimeMBean, DynamicMBean, weblogic.health.HealthFeedback, weblogic.management.runtime.JMSMessageCursorRuntimeMBean, MBeanRegistration, weblogic.management.runtime.MessageCursorRuntimeMBean, NotificationBroadcaster, weblogic.management.runtime.RuntimeMBean, weblogic.management.WebLogicMBean

public interface JMSServerRuntimeMBean
extends weblogic.management.runtime.JMSMessageCursorRuntimeMBean, weblogic.health.HealthFeedback

This class is used for monitoring a WebLogic JMS server.

### Deprecation of MBeanHome and Type-Safe Interfaces

This is a type-safe interface for a WebLogic Server MBean, which you can import into your client classes and access through `weblogic.management.MBeanHome`. As of 9.0, the `MBeanHome` interface and all type-safe interfaces for WebLogic Server MBeans are deprecated. Instead, client classes that interact with WebLogic Server MBeans should use standard JMX design patterns in which clients use the `javax.management.MBeanServerConnection` interface to discover MBeans, attributes, and attribute types at runtime. For more information, see "Developing Manageable Applications with JMX" on http://edocs.bea.com.

  Copyright © 2005 BEA Systems, Inc. All Rights Reserved.

Method Summary
`Void` | `forceCommit(String xid)` Causes the work associated with the specified transaction branch to be committed.
`Void` | `forceRollback(String xid)` Causes the work associated with the specified transaction branch to be rolled back.
`long` | `getBytesCurrentCount()` The current number of bytes stored on this JMS server.
`long` | `getBytesHighCount()` The peak number of bytes stored in the JMS server since the last reset.
`long` | `getBytesPageableCurrentCount()` Return the total number of bytes in all the messages that are currently available to be paged out, but which have not yet been paged out.
`long` | `getBytesPagedInTotalCount()` Return the total number of bytes that were read from the paging directory since the JMS server was started.
`long` | `getBytesPagedOutTotalCount()` Return the total number of bytes that were written to the paging directory since the JMS server was started.
`long` | `getBytesPendingCount()` The current number of bytes pending (unacknowledged or uncommitted) stored on this JMS server.
`long` | `getBytesReceivedCount()` The number of bytes received on this JMS server since the last reset.
`long` | `getBytesThresholdTime()` The amount of time in the threshold condition since the last reset.
`String` | `getConsumptionPausedState()` Returns the current consumption paused state of the JMSServer as string value.
`JMSDestinationRuntimeMBean[]` | `getDestinations()` An array of destinations on this JMS server.
`long` | `getDestinationsCurrentCount()` The current number of destinations for this JMS server.
`long` | `getDestinationsHighCount()` The peak number of destinations on this JMS server since the last reset.
`long` | `getDestinationsTotalCount()` The number of destinations instantiated on this JMS server since the last reset.
`weblogic.health.HealthState` | `getHealthState()` The health state of this JMS server.
`String` | `getInsertionPausedState()` Returns the current insertion paused state of the JMSServer as string value.
`String` | `getMessages(String xid, Integer timeoutSeconds)` Returns a set of messages that are associated with a JMS transaction branch.
`long` | `getMessagesCurrentCount()` The current number of messages stored on this JMS server.
`long` | `getMessagesHighCount()` The peak number of messages stored in the JMS server since the last reset.
`int` | `getMessagesPageableCurrentCount()` Return the number of messages that are currently available for paging in this JMS server but have not yet been paged out.
`int` | `getMessagesPagedInTotalCount()` Return the total number of messages that were read from the paging directory since the JMS server was started.
`int` | `getMessagesPagedOutTotalCount()` Return the total number of messages that were written to the paging directory since the JMS server was started.
`long` | `getMessagesPendingCount()` The current number of messages pending (unacknowledged or uncommitted) stored on this JMS server.
`long` | `getMessagesReceivedCount()` The number of messages received on this destination since the last reset.
`long` | `getMessagesThresholdTime()` The amount of time in the threshold condition since the last reset.
`String[]` | `getPendingTransactions()` Returns an array of Xids representing transaction branches that exist onthis JMS server in the pending state, i.e.
`String` | `getProductionPausedState()` Returns the current production paused state of the JMSServer as string value.
`JMSSessionPoolRuntimeMBean[]` | `getSessionPoolRuntimes()` The session pools running on this JMS server.
`long` | `getSessionPoolsCurrentCount()` The current number of session pools instantiated on this JMS server.
`long` | `getSessionPoolsHighCount()` The peak number of session pools instantiated on this JMS server since the last reset.
`long` | `getSessionPoolsTotalCount()` The number of session pools instantiated on this JMS server since the last reset.
`String[]` | `getTransactions()` Returns an array of Xids representing transaction branches that exist on this JMS server in any state.
`Integer` | `getTransactionStatus(String xid)` Given an Xid this method returns the JTA status of the associated JMS transaction branch.
`boolean` | `isConsumptionPaused()` Returns the current consumption paused state of the JMSServer as boolean value.
`boolean` | `isInsertionPaused()` Returns the current insertion paused state of the JMSServer as boolean value.
`boolean` | `isProductionPaused()` Returns the current production paused state of the JMSServer as boolean value.
`void` | `pauseConsumption()` Pauses the consumption operation on all the destinations hosted by the JMSServer.
`void` | `pauseInsertion()` Pauses the appearance of any messages on all the destinations of the JMSServer, that are result of the in-flight work completion on all the destinations hosted by this JMSServer.
`void` | `pauseProduction()` Pauses the new message production on all the destinations hosted by the JMSServer.
`void` | `resumeConsumption()` Resumes the consumption operation on all the destinations hosted by the JMSSever.
`void` | `resumeInsertion()` Resumes the in-flight message production operation on all the destinations hosted by the JMSServer.
`void` | `resumeProduction()` Resumes the new message production operation on all the destinations hosted by the JMSServer.

Methods inherited from interface weblogic.management.runtime.JMSMessageCursorRuntimeMBean
`sort`

Methods inherited from interface weblogic.management.runtime.MessageCursorRuntimeMBean
`getMessage, getMessage`

Methods inherited from interface weblogic.management.runtime.CursorRuntimeMBean
`closeCursor, getCursorEndPosition, getCursorSize, getCursorStartPosition, getItems, getNext, getPrevious`

Methods inherited from interface weblogic.management.WebLogicMBean
`getMBeanInfo, getName, getObjectName, getParent, getType, isCachingDisabled, isRegistered, setName, setParent`

Methods inherited from interface javax.management.DynamicMBean
`getAttribute, getAttributes, invoke, setAttribute, setAttributes`

Methods inherited from interface javax.management.MBeanRegistration
`postDeregister, postRegister, preDeregister, preRegister`

Methods inherited from interface javax.management.NotificationBroadcaster
`addNotificationListener, getNotificationInfo, removeNotificationListener`

Method Detail

### forceCommit

    public Void forceCommit(String xid)
                     throws weblogic.management.ManagementException

  Causes the work associated with the specified transaction branch to be committed.

  Parameters:
    `xid` - An xid in string representation for a JMS transaction branch.
  Throws:
    `JMSException` - thrown when an error occurs while processing the request.
    `weblogic.management.ManagementException`

### forceRollback

    public Void forceRollback(String xid)
                       throws weblogic.management.ManagementException

  Causes the work associated with the specified transaction branch to be rolled back.

  Parameters:
    `xid` - An xid in string representation for a JMS transaction branch.
  Throws:
    `JMSException` - thrown when an error occurs while processing the request.
    `weblogic.management.ManagementException`

### getBytesCurrentCount

    public long getBytesCurrentCount()

  The current number of bytes stored on this JMS server.

  This number does not include the pending bytes.

  Returns:
    The bytesCurrentCount value

### getBytesHighCount

    public long getBytesHighCount()

  The peak number of bytes stored in the JMS server since the last reset.

  Returns:
    The bytesHighCount value

### getBytesPageableCurrentCount

    public long getBytesPageableCurrentCount()

  Return the total number of bytes in all the messages that are currently available to be paged out, but which have not yet been paged out. The JMS server attempts to keep this number smaller than the "MessageBufferSize" parameter.

### getBytesPagedInTotalCount

    public long getBytesPagedInTotalCount()

  Return the total number of bytes that were read from the paging directory since the JMS server was started.

### getBytesPagedOutTotalCount

    public long getBytesPagedOutTotalCount()

  Return the total number of bytes that were written to the paging directory since the JMS server was started.

### getBytesPendingCount

    public long getBytesPendingCount()

  The current number of bytes pending (unacknowledged or uncommitted) stored on this JMS server.

  Pending bytes are over and above the current number of bytes.

  Returns:
    The bytesPendingCount value

### getBytesReceivedCount

    public long getBytesReceivedCount()

  The number of bytes received on this JMS server since the last reset.

  Returns:
    The bytesReceivedCount value

### getBytesThresholdTime

    public long getBytesThresholdTime()

  The amount of time in the threshold condition since the last reset.

  Returns:
    The bytesThresholdTime value

### getConsumptionPausedState

    public String getConsumptionPausedState()

  Returns the current consumption paused state of the JMSServer as string value.

  Returns:
    The possible values are:
    - Consumption-Paused - indicates that the JMSServer and all of its destinations are currently paused for message consumption by the consumers. operation.
    - Consumption-Pausing - indicates that the JMSServer in the process of pausing all the destinations for message consumption by the consumers.
    - Consumption-Enabled - indicates that the JMSServer is not currently paused for message consumption by the consumers.

### getDestinations

    public JMSDestinationRuntimeMBean[] getDestinations()

  An array of destinations on this JMS server.

  Returns:
    The destinations value

### getDestinationsCurrentCount

    public long getDestinationsCurrentCount()

  The current number of destinations for this JMS server.

  Returns:
    The destinationsCurrentCount value

### getDestinationsHighCount

    public long getDestinationsHighCount()

  The peak number of destinations on this JMS server since the last reset.

  Returns:
    The destinationsHighCount value

### getDestinationsTotalCount

    public long getDestinationsTotalCount()

  The number of destinations instantiated on this JMS server since the last reset.

  Returns:
    The destinationsTotalCount value

### getHealthState

    public weblogic.health.HealthState getHealthState()

  The health state of this JMS server.

  Specified by:
    `getHealthState` in interface `weblogic.health.HealthFeedback`
  Returns:
    The healthState value

### getInsertionPausedState

    public String getInsertionPausedState()

  Returns the current insertion paused state of the JMSServer as string value.

  Returns:
    The possible values are:
    - Insertion-Paused - indicates that the JMSServer and all of its destinations are currently paused for new message as in-flight message production.
    - Insertion-Pausing - indicates that the JMSServer in the process of pausing all the destinations for new message as well as in-flight message production.
    - Insertion-Enabled - indicates that the JMSServer is not currently paused for in-flight message production.

### getMessages

    public String getMessages(String xid,
                              Integer timeoutSeconds)
                       throws weblogic.management.ManagementException

  Returns a set of messages that are associated with a JMS transaction branch. Note that the result set is returned to the caller in the form of a message cursor that may contain messages from several destinations on this JMS server. The timeout parameter specifies the amount of time in seconds for which the cursor is valid. Upon timeout expiration the cursor is invalidated and the associated resources released.

  Parameters:
    `xid` - An Xid in string representation for a JMS transaction branch.
    `timeoutSeconds` - The last access timeout for the cursor. The cursor resources will be reclaimed if it is not accessed within the specified time interval. A value of 0 indicates no timeout.
  Returns:
    A message cursor containing messages associated with the transaction branch, possibly from multiple destinations.
  Throws:
    `JMSException` - thrown when an error occurs while processing the request.
    `weblogic.management.ManagementException`
  See Also:
    `Xid`, `JMSMessageCursorRuntimeMBean`

### getMessagesCurrentCount

    public long getMessagesCurrentCount()

  The current number of messages stored on this JMS server. This number does not include the pending messages.

  Returns:
    The messagesCurrentCount value

### getMessagesHighCount

    public long getMessagesHighCount()

  The peak number of messages stored in the JMS server since the last reset.

  Returns:
    The messagesHighCount value

### getMessagesPageableCurrentCount

    public int getMessagesPageableCurrentCount()

  Return the number of messages that are currently available for paging in this JMS server but have not yet been paged out. Note that due to internal implementation details, this count may be zero even if "PageableByteCurrentCount" is zero.

### getMessagesPagedInTotalCount

    public int getMessagesPagedInTotalCount()

  Return the total number of messages that were read from the paging directory since the JMS server was started.

### getMessagesPagedOutTotalCount

    public int getMessagesPagedOutTotalCount()

  Return the total number of messages that were written to the paging directory since the JMS server was started.

### getMessagesPendingCount

    public long getMessagesPendingCount()

  The current number of messages pending (unacknowledged or uncommitted) stored on this JMS server.

  Pending messages are over and above the current number of messages.

  Returns:
    The messagesPendingCount value

### getMessagesReceivedCount

    public long getMessagesReceivedCount()

  The number of messages received on this destination since the last reset.

  Returns:
    The messagesReceivedCount value

### getMessagesThresholdTime

    public long getMessagesThresholdTime()

  The amount of time in the threshold condition since the last reset.

  Returns:
    The messagesThresholdTime value

### getPendingTransactions

    public String[] getPendingTransactions()

  Returns an array of Xids representing transaction branches that exist onthis JMS server in the pending state, i.e. branches that have been prepared by the transaction manager but not yet committed or rolled back.

  Returns:
    An array of Xids in string representation.
  See Also:
    `Xid`

### getProductionPausedState

    public String getProductionPausedState()

  Returns the current production paused state of the JMSServer as string value.

  Returns:
    The possible values are:
    - Production-Paused - indicates that the JMSServer and all of its destinations are currently paused for new message production.
    - Production-Pausing - indicates that the JMSServer is in the process of pausing all the destinations for new message production.
    - Production-Enabled - indicates that the JMSServer is not currently paused for new message prdoduction.

### getSessionPoolRuntimes

    public JMSSessionPoolRuntimeMBean[] getSessionPoolRuntimes()

  The session pools running on this JMS server.

  Returns:
    The sessionPoolRuntimes value

### getSessionPoolsCurrentCount

    public long getSessionPoolsCurrentCount()

  The current number of session pools instantiated on this JMS server.

  Returns:
    The sessionPoolsCurrentCount value

### getSessionPoolsHighCount

    public long getSessionPoolsHighCount()

  The peak number of session pools instantiated on this JMS server since the last reset.

  Returns:
    The sessionPoolsHighCount value

### getSessionPoolsTotalCount

    public long getSessionPoolsTotalCount()

  The number of session pools instantiated on this JMS server since the last reset.

  Returns:
    The sessionPoolsTotalCount value

### getTransactions

    public String[] getTransactions()

  Returns an array of Xids representing transaction branches that exist on this JMS server in any state.

  Returns:
    An array of Xids in string representation.
  See Also:
    `Xid`

### getTransactionStatus

    public Integer getTransactionStatus(String xid)

  Given an Xid this method returns the JTA status of the associated JMS transaction branch.

  Parameters:
    `xid` - An Xid in string representation for a JMS transaction branch.
  Returns:
    An integer value representing a JTA transaction state.
  See Also:
    `Xid`, `Status`

### isConsumptionPaused

    public boolean isConsumptionPaused()

  Returns the current consumption paused state of the JMSServer as boolean value.

  Returns:
    returns true if the JMSServer is currently paused for consumption of messages, false otherwise.
  Throws:
    `JMSException` - Thrown when an internal JMS error occurs while pausing the consumption.

### isInsertionPaused

    public boolean isInsertionPaused()

  Returns the current insertion paused state of the JMSServer as boolean value.

  Returns:
    returns true if the JMSServer is currently paused for insertion of the in-flight messages, false otherwise.

### isProductionPaused

    public boolean isProductionPaused()

  Returns the current production paused state of the JMSServer as boolean value.

  Returns:
    returns true if the JMSServer is currently paused for new message production, false otherwise.

### pauseConsumption

    public void pauseConsumption()
                          throws JMSException

  Pauses the consumption operation on all the destinations hosted by the JMSServer.

  When the JMSServer is paused for consumption, all of its destination's state is marked as "consumption paused" and all the new synchronous receive operations will block until the destination is resumed and there are messages available for consumption. All the synchronous receive with blocking timeout will block until the timeout happens during the consumption paused state.

  All the asynchronous consumers attached to that destination will not get any messages delivered to them while the destination in "consumption paused" state.

  After a successful consumption "pause" operation, the user has to explicitly "resume" the destination to allow for any further consume operations on that destination

  Throws:
    `JMSException`

### pauseInsertion

    public void pauseInsertion()
                        throws JMSException

  Pauses the appearance of any messages on all the destinations of the JMSServer, that are result of the in-flight work completion on all the destinations hosted by this JMSServer.

  Definition of In-Flight work

  The definitions below are based on the current implementation of WebLogic JMS subsystem.

  In-flight messages associated with Producers

  - UN-BORN MESSAGES

    Messages that are produced by the producer, with "birth time" (TimeToDeliver) set in future are called un-born messages and are counted as "pending" messages in the destination statistics and are not available for consumers yet.

  - UN-COMMITTED MESSAGES

    These are the messages that are produced by the producer as part of the transaction (using either user transaction or transacted session) and the transaction is still not committed or rolled back. These messages are also counted as "pending" messages in the destination statistics and are not available for consumption.

  - QUOTA BLOCKING SEND

    These are the messages that are produced by the producers but are not able reach the destination because of (either message or byte or both) quota limit on the destination and the producers are willing to block for a specific period of time for the quota to be available. These messages are invisible to the system and are not counted against any of the destination statistics.

  In-flight messages associated with Consumers

  - UN-ACKNOWLEDGED (CLIENT ACK PENDING) MESSAGES

    These are the messages that are successfully consumed by the clients using a "client acknowledge" session, and are awaiting acknowledgements from the clients. These are "pending messages" which will be removed from the destination/system when the acknowledgement is received.

  - UN-COMMITTED MESSAGES

    These are the messages that are consumed (received) by the clients within a transaction (using either user transaction or transacted session) and the transaction is still not committed or rolled back. When the clients successfully commit the transaction the messages get removed from the system.

  - ROLLED BACK MESSAGES

    These are the messages that are put back on the destination because of a successful rollback of transactional receive by the consumers. These messages might or might not be ready for consumption (re-delivered) to the clients immediately, depending on the redelivery parameters, RedeliveryDelay and/or RedeliveryDelayOverride and RedeliveryLimit configured on the associated JMSConnectionFactory and JMSDestination respectively.

    If there is a redelivery delay configured, then for that "delay" duration, the messages are not available for consumption and are counted as "pending" in the destination statistics and after the "delay" period, if the redelivery limit is not exceeded, then they are delivered (made available for consumption) on that destination and are counted as "current" messages in the destination statistics. If the redelivery limit exceeds, then those messages will be moved to the ErrorDestination, if one configured.

    Another parameter that controls the availability of the rolled back messages is RedeliveryLimit.

  - RECOVERED MESSAGES

    These messages are similar to ROLLED BACK MESSAGES discussed above. Except that these messages appear on the queue because of an explicit call to session "recover" by the client.

  - REDELIVERED MESSAGES

    These are again similar to ROLLED BACK MESSAGES except that these messages may re-appear on the destination because of an un-successful delivery attempt to the client (consumer crash, close etc.).

  Throws:
    `JMSException` - Thrown when an internal JMS error occurs while pausing the insertion.
  See Also:
    `resumeInsertion()`, `pauseProduction()`, `pauseConsumption()`

### pauseProduction

    public void pauseProduction()
                         throws JMSException

  Pauses the new message production on all the destinations hosted by the JMSServer.

  When the production paused, it would prevent any new produce operations from both new and existing producers attached to the destinations. When the destination is "resumed from production pause", all the new message production is allowed from both new and existing producers attached to that destination.

  Throws:
    `JMSException` - Thrown when an internal JMS error occurs while pausing the production.
  See Also:
    `resumeProduction()`, `pauseInsertion()`, `pauseConsumption()`

### resumeConsumption

    public void resumeConsumption()
                           throws JMSException

  Resumes the consumption operation on all the destinations hosted by the JMSSever.

  The state of the destinations shall be marked as "consumption enabled" thus allowing all the "consuming" activity to continue normally.

  Invoking this API on a JMSServer that is currently not in "consumption paused" state has no effect.

  Throws:
    `JMSException` - Thrown when an internal JMS error occurs while resuming the consumption.

### resumeInsertion

    public void resumeInsertion()
                         throws JMSException

  Resumes the in-flight message production operation on all the destinations hosted by the JMSServer. The state of the JMSServer shall be marked as "insertion enabled" thus allowing all the messages from in-flight work completion are alloed to appear on the destinations. Invoking this API on a JMSServer that is currently not in "insertion paused" state has no effect.

  Throws:
    `JMSException` - Thrown when an internal JMS error occurs while resuming the insertion.

### resumeProduction

    public void resumeProduction()
                          throws JMSException

  Resumes the new message production operation on all the destinations hosted by the JMSServer. The state of the JMSServer shall be marked as "production enabled" thus allowing all the new "producing" activity to continue normally. Invoking this API on a JMSServer that is currently not in "production paused" state has no effect.

  Throws:
    `JMSException` - Thrown when an internal JMS error occurs while resuming the production.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| Documentation is available at http://e-docs.bea.com/wls/docs91 Copyright 2005 BEA Systems Inc.
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD